diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_statistics.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_statistics.py
new file mode 100644
index 000000000..d916856eb
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_get_statistics.py
@@ -0,0 +1,57 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentGetStatsTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job stats API"""
+    scenarios = utils.generate_scenarios("pgagent_job_get_statistics",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get_stats%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+    def runTest(self):
+        """This function will get pgAgent job stats"""
+
+        if self.is_positive_test:
+            response = pgagent_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_get(self)
+
+                # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_put.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_put.py
new file mode 100644
index 000000000..b9dcfe793
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_put.py
@@ -0,0 +1,64 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+from unittest.mock import patch
+
+import simplejson as json
+import uuid
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentPutTestCase(BaseTestGenerator):
+    """This class will test the put pgAgent job API"""
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("pgagent_job_put",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_put%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+    def runTest(self):
+        """This function will put pgAgent job"""
+
+        if 'jschedules' in self.data and 'added' in self.data['jschedules']:
+            self.data['jschedules']['added'][0]['jscjobid'] = self.job_id
+
+        if 'jsteps' in self.data and 'added' in self.data['jsteps']:
+            self.data['jsteps']['added'][0]['jstjobid'] = self.job_id
+
+        if self.is_positive_test:
+            response = pgagent_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_sql.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_sql.py
new file mode 100644
index 000000000..3afa32214
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/test_pgagent_job_sql.py
@@ -0,0 +1,70 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from . import utils as pgagent_utils
+
+
+class PgAgentSqlTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job sql API"""
+    scenarios = utils.generate_scenarios("pgagent_job_sql",
+                                         pgagent_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_sql%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        sch_name = "test_schedule_update%s" % str(uuid.uuid4())[1:8]
+        self.schedule_id = pgagent_utils.create_pgagent_schedule(
+            self, sch_name, self.job_id)
+
+        self.excp_id = pgagent_utils.create_pgagent_exception(
+            self, self.schedule_id, "2050-01-01", "12:00:00")
+
+    def runTest(self):
+        """This function will get pgAgent job sql"""
+
+        if self.is_positive_test:
+            response = pgagent_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_get(self)
+            elif 'job_id' in self.data:
+                # Non-existing job id
+                existing_job_id = self.job_id
+                self.job_id = self.data["job_id"]
+                response = pgagent_utils.api_get(self)
+                self.job_id = existing_job_id
+
+                # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/utils.py b/web/pgadmin/browser/server_groups/servers/pgagent/tests/utils.py
index a4d802a6a..3875bafc9 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/utils.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/tests/utils.py
@@ -9,11 +9,64 @@
 
 import sys
 import traceback
+import os
+import json
+from urllib.parse import urlencode
 
 from regression.python_test_utils import test_utils as utils
 from regression import parent_node_dict
 from pgadmin.utils import server_utils as server_utils
 
+# Load test data from json file.
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/pgagent_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+# api methods
+def api_create(self):
+    return self.tester.post('{0}{1}/{2}/'.
+                            format(self.url, str(utils.SERVER_GROUP),
+                                   str(self.server_id)),
+                            data=json.dumps(self.data),
+                            content_type='html/json')
+
+
+def api_get(self, job_id=None):
+    if job_id is None:
+        job_id = self.job_id
+    return self.tester.get('{0}{1}/{2}/{3}'.
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, job_id),
+                           content_type='html/json')
+
+
+def api_put(self):
+    return self.tester.put('{0}{1}/{2}/{3}'.
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id),
+                           data=json.dumps(self.data),
+                           follow_redirects=True,
+                           content_type='html/json')
+
+
+def api_get_msql(self, url_encode_data):
+    return self.tester.get("{0}{1}/{2}/{3}?{4}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id,
+                                  urlencode(url_encode_data)),
+                           follow_redirects=True)
+
+
+def api_delete(self, job_id=None):
+    if job_id is None:
+        job_id = self.job_id
+    return self.tester.delete('{0}{1}/{2}/{3}'.
+                              format(self.url, utils.SERVER_GROUP,
+                                     self.server_id, job_id),
+                              data=json.dumps(self.data),
+                              content_type='html/json')
+
 
 def is_valid_server_to_run_pgagent(self):
     """
@@ -121,10 +174,12 @@ def create_pgagent_job(self, name):
         traceback.print_exc(file=sys.stderr)
 
 
-def delete_pgagent_job(self):
+def delete_pgagent_job(self, job_id=None):
     """
     This function deletes the pgAgent job.
     """
+    if job_id is None:
+        job_id = self.job_id
     try:
         connection = utils.get_db_connection(
             self.server['db'],
@@ -139,7 +194,7 @@ def delete_pgagent_job(self):
         pg_cursor = connection.cursor()
         pg_cursor.execute(
             "DELETE FROM pgagent.pga_job "
-            "WHERE jobid = '%s'::integer;" % self.job_id
+            "WHERE jobid = '%s'::integer;" % job_id
         )
         connection.set_isolation_level(old_isolation_level)
         connection.commit()
diff --git a/web/regression/runtests.py b/web/regression/runtests.py
index a62358fac..c619f74a2 100644
--- a/web/regression/runtests.py
+++ b/web/regression/runtests.py
@@ -681,10 +681,11 @@ def print_test_results():
         failed_cases, failed_cases_json = test_utils.get_scenario_name(
             failed_cases)
 
-        total_failed = len(dict((key, value) for key, value in
-                                failed_cases.items()).values())
-        total_skipped = len(dict((key, value) for key, value in
-                                 skipped_cases.items()).values())
+        total_failed = sum(list((len(value)) for key, value in
+                                failed_cases.items()))
+        total_skipped = sum(list((len(value)) for key, value in
+                                 skipped_cases.items()))
+
         total_passed_cases = int(
             test_result[server_res][0]) - total_failed - total_skipped
 
